=== added file 'ChangeLog'
--- ChangeLog	1970-01-01 00:00:00 +0000
+++ ChangeLog	2009-05-04 14:17:06 +0000
@@ -0,0 +1,366 @@
+2009-05-04  Guillaume Chazarain <guichaz@gmail.com>
+
+	* NEWS, THANKS, iotop.1, iotop/ui.py: Added --quiet
+
+2009-05-03  Guillaume Chazarain <guichaz@gmail.com>
+
+	* NEWS, THANKS, iotop.1, iotop/ui.py: Added --time
+
+2009-05-02  Guillaume Chazarain <guichaz@gmail.com>
+
+	* NEWS, iotop.1, iotop/data.py, iotop/ui.py: Added the -k,
+	--kilobytes option
+
+2009-05-02  Guillaume Chazarain <guichaz@gmail.com>
+
+	* MANIFEST.in, setup.py: Upgrade setuptools from 0.6c6 to 0.6c9
+
+2009-03-31  Guillaume Chazarain <guichaz@gmail.com>
+
+	* MANIFEST.in, release.sh, setup.cfg: Include a ChangeLog in the
+	release
+
+2009-03-30  Guillaume Chazarain <guichaz@gmail.com>
+
+	* iotop/data.py: Put kernel threads between square brackets
+
+2009-03-30  Guillaume Chazarain <guichaz@gmail.com>
+
+	* iotop/ui.py: Properly sanitize the value in the error report
+
+2009-03-30  Guillaume Chazarain <guichaz@gmail.com>
+
+	* NEWS, iotop.1, iotop/data.py, iotop/ui.py: - Added the --accumulated option to show the accumulated traffic
+	instead of the current bandwidth (dynamically toggled with 'a') - Resist to process dying during the taskstats retrieval - Adjusted column headers
+
+2009-03-29  Guillaume Chazarain <guichaz@gmail.com>
+
+	* NEWS: Document some recent changes
+
+2009-03-29  Guillaume Chazarain <guichaz@gmail.com>
+
+	* iotop/data.py, iotop/ui.py, iotop/vmstat.py: - Manage a two level tree of processes: o with --processes:
+	[tgids...] -> [tid...] o without: [tids...] -> [tid] => This handles
+	nicely the case where a thread dies during a sampling period and we
+	should drop its stats.  - Don't cache the ioprio as it may change - Get the total I/O bandwidth from /proc/vmstat instead of summing
+	it, as we can count some of it twice (ntfs-3g, nfsd...)
+
+2009-03-29  Guillaume Chazarain <guichaz@gmail.com>
+
+	* iotop/ui.py: Added --profile
+
+2009-03-29  Guillaume Chazarain <guichaz@gmail.com>
+
+	* iotop/data.py: Don't crash when a thread just disappeared
+
+2009-03-29  Guillaume Chazarain <guichaz@gmail.com>
+
+	* iotop/data.py, iotop/ui.py: Better UID detection: read it from
+	stat(/proc/PID) instead of /proc/PID/status and cache it only if not
+	running as root as the process may setuid().  Rewrite
+	check_if_valid() to is_monitored().  Also re-read /proc/PID/status
+	if needed when re-reading /proc/PID/cmdline.
+
+2009-01-31  Guillaume Chazarain <guichaz@gmail.com>
+
+	* THANKS, iotop/ui.py: From: Ryan Lovett <ryan@stat.berkeley.edu>
+	When running in batch mode, iotop doesn't flush its output so if
+	you're writing to a file, you won't see anything (e.g. via 'tail
+	-f') until iotop terminates
+
+2008-12-29  Guillaume Chazarain <guichaz@gmail.com>
+
+	* iotop/data.py: Add a meaningful __repr__()
+
+2008-12-29  Guillaume Chazarain <guichaz@gmail.com>
+
+	* iotop/data.py: If a new pinfo() is successfully created but we
+	cannot get its taskstats, it will not have a .ioprio field, so it
+	must be garbage collected. So, initialize .mark to False so that
+	incompletely built objects are garbage collected.  Traceback (most recent call last):   File "./iotop.py", line 11, in <module>     main()   File "/home/g/iotop/iotop/ui.py", line 271, in main     curses.wrapper(run_iotop, options)   File "/usr/lib/python2.5/curses/wrapper.py", line 44, in wrapper     return func(stdscr, *args, **kwds)   File "/home/g/iotop/iotop/ui.py", line 226, in run_iotop     ui.run()   File "/home/g/iotop/iotop/ui.py", line 97, in run     self.process_list.duration)   File "/home/g/iotop/iotop/ui.py", line 195, in refresh_display     lines = self.get_data()   File "/home/g/iotop/iotop/ui.py", line 183, in get_data     return map(format, processes)   File "/home/g/iotop/iotop/ui.py", line 167, in format     line = '%5d %4s %-8s %11s %11s %7s %7s ' % (p.pid, p.ioprio,
+	AttributeError: 'pinfo' object has no attribute 'ioprio'
+
+2008-12-28  Guillaume Chazarain <guichaz@gmail.com>
+
+	* iotop/data.py: The I/O priority can be dynamically changed, so we
+	must re-fetch it every time.
+
+2008-12-28  Guillaume Chazarain <guichaz@gmail.com>
+
+	* iotop.1, iotop/ui.py: Added the 'p' key to dynamically toggle the
+	--processes option
+
+2008-12-25  Guillaume Chazarain <guichaz@gmail.com>
+
+	* iotop/ui.py: The interactive control 'O' is the same as 'o'.
+
+2008-12-25  Guillaume Chazarain <guichaz@gmail.com>
+
+	* iotop.1, iotop/data.py, iotop/ioprio.py, iotop/ui.py: Added
+	support for showing the I/O priority
+
+2008-12-23  Guillaume Chazarain <guichaz@gmail.com>
+
+	* iotop/ui.py: More verbose error handling for this exception:
+	Traceback (most recent call last):  File "./iotop.py", line 11, in <module>    main()  File "/src/iotop/iotop/iotop/ui.py", line 249, in main    curses.wrapper(run_iotop, options)  File "/usr/lib64/python2.5/curses/wrapper.py", line 44, in wrapper    return func(stdscr, *args, **kwds)  File "/src/iotop/iotop/iotop/ui.py", line 205, in run_iotop    ui.run()  File "/src/iotop/iotop/iotop/ui.py", line 95, in run    self.process_list.duration)  File "/src/iotop/iotop/iotop/ui.py", line 198, in refresh_display    self.win.addstr(i + 2, 0, lines[i].encode('utf-8'))
+	_curses.error: addstr() returned ERR
+
+2008-11-16  Guillaume Chazarain <guichaz@gmail.com>
+
+	* iotop/ui.py: Also keep only 2 decimal digits when printing bytes
+	per second
+
+2008-09-07  Guillaume Chazarain <guichaz@gmail.com>
+
+	* NEWS, iotop/version.py: Version bump and mention that -P is now
+	fully implemented
+
+2008-09-07  Guillaume Chazarain <guichaz@gmail.com>
+
+	* iotop.1, iotop/ui.py: Clarify -p help text, and cosmetically add a
+	terminating '.'.
+
+2008-09-07  Guillaume Chazarain <guichaz@gmail.com>
+
+	* iotop.1: iotop is a mix of top(1) and vmstat(1)
+
+2008-09-07  Guillaume Chazarain <guichaz@gmail.com>
+
+	* iotop.1, iotop/data.py: Precisely document required kernel options
+	http://bugs.debian.org/497360
+
+2008-09-06  Guillaume Chazarain <guichaz@gmail.com>
+
+	* iotop/data.py: Reimplement -P without using the half implemented
+	TASKSTATS_CMD_ATTR_TGID
+
+2008-09-06  Guillaume Chazarain <guichaz@gmail.com>
+
+	* iotop/data.py, iotop/ui.py: Cleanup: introduce a Stats class to
+	aggregate the useful output from taskstats insteaf of using a dict.
+
+2008-08-18  Guillaume Chazarain <guichaz@gmail.com>
+
+	* iotop/data.py: It seems the Name: field can sometimes be empty.
+	http://bugs.debian.org/492568
+
+2008-08-18  Guillaume Chazarain <guichaz@gmail.com>
+
+	* iotop/data.py: Cosmetic
+
+2008-07-07  Guillaume Chazarain <guichaz@gmail.com>
+
+	* NEWS, iotop/version.py: The new features list is not that long
+
+2008-06-24  Guillaume Chazarain <guichaz@gmail.com>
+
+	* iotop/data.py: Also handle invalid UTF-8
+
+2008-06-23  Guillaume Chazarain <guichaz@gmail.com>
+
+	* iotop/ui.py: Unlike insstr, addstr is picky about lines wider than
+	the terminal.
+
+2008-06-23  Guillaume Chazarain <guichaz@gmail.com>
+
+	* iotop/data.py, iotop/ui.py: Try harder at handling UTF-8
+
+2008-06-18  Guillaume Chazarain <guichaz@gmail.com>
+
+	* NEWS, THANKS, iotop/data.py, iotop/ui.py: UTF-8 strings are now
+	correctly handled.
+
+2008-06-18  Guillaume Chazarain <guichaz@gmail.com>
+
+	* NEWS, iotop/version.py: Bump version
+
+2008-05-28  Guillaume Chazarain <guichaz@gmail.com>
+
+	* iotop.1: Fix for
+
+	http://lintian.debian.org/reports/tags/hyphen-used-as-minus-sign.html
+
+2008-05-23  Guillaume Chazarain <guichaz@gmail.com>
+
+	* MANIFEST.in, install-rpm.sh, setup.cfg, setup.py: Package the man
+	page
+
+2008-05-22  Guillaume Chazarain <guichaz@gmail.com>
+
+	* iotop/ui.py: Reordered the option like in the man page, as it's a
+	more sensible ordering
+
+2008-05-22  Guillaume Chazarain <guichaz@gmail.com>
+
+	* THANKS, iotop.1: Added a man page
+
+2008-05-22  Guillaume Chazarain <guichaz@gmail.com>
+
+	* iotop/ui.py: Safer color terminal handling
+
+2008-05-22  Guillaume Chazarain <guichaz@gmail.com>
+
+	* iotop/ui.py: Stop flickering during refresh
+
+2008-05-22  Guillaume Chazarain <guichaz@gmail.com>
+
+	* NEWS, iotop/data.py, iotop/ui.py: Added workaround for missing
+	ac_etime in TASKSTATS_CMD_ATTR_TGID
+
+2008-04-20  Guillaume Chazarain <guichaz@gmail.com>
+
+	* NEWS: Typo
+
+2008-04-20  Guillaume Chazarain <guichaz@gmail.com>
+
+	* iotop/ui.py: Document the 'o' key.
+
+2008-04-20  Guillaume Chazarain <guichaz@gmail.com>
+
+	* iotop/ui.py: Consistency in the grammar
+
+2008-04-20  Guillaume Chazarain <guichaz@gmail.com>
+
+	* iotop/ui.py: Filter processes to display before trimming them to
+	avoid removing processes that would be displayed after the trimming.
+	For example, sorting by PID could place I/O active processes at the
+	end, but we don't want to delete them as they would be shown anyway
+	is -o is used.
+
+2008-04-06  Guillaume Chazarain <guichaz@gmail.com>
+
+	* NEWS, iotop/ui.py: Typing 'p' dynamically toggle the --only option
+
+2008-03-20  Guillaume Chazarain <guichaz@gmail.com>
+
+	* bin/iotop: Detect unsuccessful attempts at running an uninstalled
+	iotop
+
+2008-03-14  Guillaume Chazarain <guichaz@gmail.com>
+
+	* iotop.py, run-iotop: Let's use the obvious filename
+
+2008-03-10  Guillaume Chazarain <guichaz@gmail.com>
+
+	* release.sh: Remove blank line
+
+2008-03-10  Guillaume Chazarain <guichaz@gmail.com>
+
+	* release.sh: Added release script
+
+2008-03-09  Guillaume Chazarain <guichaz@yahoo.fr>
+
+	* MANIFEST.in, bin/iotop, setup.cfg, setup.py: Added packaging
+	information
+
+2008-03-09  Guillaume Chazarain <guichaz@yahoo.fr>
+
+	* iotop/ui.py, iotop/version.py: Extracted out version number
+
+2008-03-09  Guillaume Chazarain <guichaz@yahoo.fr>
+
+	* COPYING: Added GPLv2 COPYING file
+
+2008-03-09  Guillaume Chazarain <guichaz@yahoo.fr>
+
+	* THANKS: Added THANKS file
+
+2008-03-09  Guillaume Chazarain <guichaz@yahoo.fr>
+
+	* .gitignore: Ignore byte compiled files
+
+2008-03-09  Guillaume Chazarain <guichaz@yahoo.fr>
+
+	* NEWS: Added NEWS file
+
+2008-03-09  Guillaume Chazarain <guichaz@yahoo.fr>
+
+	* genetlink.py, iotop.py, iotop/__init__.py, iotop/data.py,
+	iotop/genetlink.py, iotop/netlink.py, iotop/ui.py, netlink.py,
+	run-iotop: Code reorganization
+
+2008-03-05  Guillaume Chazarain <guichaz@yahoo.fr>
+
+	* genetlink.py, iotop.py, netlink.py: Instead of copy/pasting
+	pynl80211 in iotop.py, keep it in separate files
+
+2008-03-05  Guillaume Chazarain <guichaz@yahoo.fr>
+
+	* iotop.py: Update e-mail and copyright information
+
+2008-03-05  Guillaume Chazarain <guichaz@yahoo.fr>
+
+	* iotop.py: Reading the cmdline of a dead process raises an
+	exception too.  Reported by Roland Kletzing <devzero@web.de>
+
+2008-03-02  Guillaume Chazarain <guichaz@yahoo.fr>
+
+	* iotop.py: Skip the dirname only when the cmdline starts with an
+	absolute path
+
+2008-01-20  Guillaume Chazarain <guichaz@yahoo.fr>
+
+	* iotop.py: Fix the typo with the right correction this time
+
+2008-01-20  Guillaume Chazarain <guichaz@yahoo.fr>
+
+	* iotop.py: Simplify help generation
+
+2008-01-18  Guillaume Chazarain <guichaz@yahoo.fr>
+
+	* iotop.py: Bump version
+
+2008-01-18  Guillaume Chazarain <guichaz@yahoo.fr>
+
+	* iotop.py: Removed embedded history comments as it is now in git.
+
+2008-01-18  Guillaume Chazarain <guichaz@yahoo.fr>
+
+	* iotop.py: Added --only as suggested by Iain Lea <iain@bricbrac.de>
+
+2008-01-18  Guillaume Chazarain <guichaz@yahoo.fr>
+
+	* iotop.py: Fix typo, reported by Iain Lea <iain@bricbrac.de>
+
+2007-12-19  Guillaume Chazarain <guichaz@yahoo.fr>
+
+	* iotop.py: Tolerate misconfigured terminals
+
+2007-09-30  Guillaume Chazarain <guichaz@yahoo.fr>
+
+	* iotop.py: Fixed -b
+
+2007-08-26  Guillaume Chazarain <guichaz@yahoo.fr>
+
+	* iotop.py: Document taskstats bug:
+	http://lkml.org/lkml/2007/8/2/185
+
+2007-08-25  Guillaume Chazarain <guichaz@yahoo.fr>
+
+	* iotop.py: Handle terminal resizing
+
+2007-08-25  Guillaume Chazarain <guichaz@yahoo.fr>
+
+	* iotop.py: More accurate cutting of the command line
+
+2007-08-19  Guillaume Chazarain <guichaz@yahoo.fr>
+
+	* iotop.py: handle empty process list
+
+2007-08-19  Guillaume Chazarain <guichaz@yahoo.fr>
+
+	* iotop.py: Fix "-P -p NOT_A_TGID", optimize -p
+
+2007-08-13  Guillaume Chazarain <guichaz@yahoo.fr>
+
+	* iotop.py: Handle short replies, and fix bandwidth calculation when
+	delay != 1s
+
+2007-07-23  Guillaume Chazarain <guichaz@yahoo.fr>
+
+	* iotop.py: Added support for taskstats version > 4 in iotop.py
+
+2007-07-15  Guillaume Chazarain <guichaz@yahoo.fr>
+
+	* Initial import of iotop
+

=== modified file 'MANIFEST.in'
--- MANIFEST.in	2008-05-29 17:31:58 +0000
+++ MANIFEST.in	2009-05-04 14:17:06 +0000
@@ -1,5 +1,6 @@
 include COPYING
+include ChangeLog
 include NEWS
 include THANKS
 include iotop.1
-include setuptools-0.6c6-py2.4.egg
+include setuptools-0.6c9-py2.4.egg

=== modified file 'NEWS'
--- NEWS	2009-02-24 18:09:50 +0000
+++ NEWS	2009-05-04 14:17:06 +0000
@@ -1,3 +1,9 @@
+0.3
+~~~
+o -P is now fully implemented and is dynamically toggled with 'p'
+o Show the I/O priority
+o Added the --accumulated, --kilobytes, --time and --quiet options
+
 0.2.1
 ~~~~~
 o UTF-8 strings are now correctly handled

=== modified file 'THANKS'
--- THANKS	2009-02-24 18:09:50 +0000
+++ THANKS	2009-05-04 14:17:06 +0000
@@ -13,3 +13,10 @@
 
 Göran Uddeborg <goeran@uddeborg.se>
     Reported that iotop was misbehaving with UTF-8 strings.
+
+Ryan Lovett <ryan@stat.berkeley.edu>
+    Contributed a bugfix: flush the output in batch mode, so that a potential
+output file is updated.
+
+Martin Bammer <mrbm74@gmail.com>
+    Initial implementation of the --time and --quiet options.

=== modified file 'iotop.1'
--- iotop.1	2009-02-24 18:09:50 +0000
+++ iotop.1	2009-05-04 14:17:06 +0000
@@ -1,5 +1,5 @@
 .\" Debian manual page, has been forwarded upstream
-.TH IOTOP "1" "May 2008"
+.TH IOTOP "1" "April 2009"
 .SH NAME
 iotop \- simple top\-like I/O monitor
 .SH SYNOPSIS
@@ -8,17 +8,18 @@
 .SH DESCRIPTION
 iotop watches I/O usage information output by the Linux kernel (requires
 2.6.20 or later) and displays a table of current I/O usage by processes
-or threads on the system. At least the CONFIG_TASKSTATS and CONFIG_TASK_IO_ACCOUNTING
-options need to be enabled in your Linux kernel build configuration.
+or threads on the system. At least the CONFIG_TASK_DELAY_ACCT and
+CONFIG_TASK_IO_ACCOUNTING options need to be enabled in your Linux kernel
+build configuration, these options depend on CONFIG_TASKSTATS.
 .PP
 iotop displays columns for the I/O bandwidth read and written by each
 process/thread during the sampling period. It also displays the percentage
-of time the thread/process spent while swapping in and while waiting on I/O.
-In addition the total I/O bandwidth read and written during the sampling
+of time the thread/process spent while swapping in and while waiting on I/O. For each process, its I/O priority (class/level) is shown.
+In addition, the total I/O bandwidth read and written during the sampling
 period is displayed at the top of the interface.
 .PP
 Use the left and right arrows to change the sorting, r to reverse the
-sorting order, o to toggle the \-\-only option or q to quit. Any other key will force a refresh.
+sorting order, o to toggle the \-\-only option, p to toggle the \-\-processes option, a to toggle the --accumulated option or q to quit. Any other key will force a refresh.
 .SH OPTIONS
 .TP
 \fB\-\-version\fR
@@ -43,15 +44,41 @@
 Accepts non-integer values such as 1.1 seconds.
 .TP
 \fB\-p\fR PID, \fB\-\-pid\fR=\fIPID\fR
-A list of processes to monitor (all by default).
+A list of processes/threads to monitor (all by default).
 .TP
 \fB\-u\fR USER, \fB\-\-user\fR=\fIUSER\fR
 A list of users to monitor (all by default)
 .TP
 \fB\-P\fR, \fB\-\-processes\fR
 Only show processes. Normally iotop shows all threads.
+.TP
+\fB\-a\fR, \fB\-\-accumulated\fR
+Show accumulated I/O instead of bandwidth. In this mode, iotop shows the amount of I/O processes have done since iotop started.
+.TP
+\fB\-k\fR, \fB\-\-kilobytes\fR
+Use kilobytes instead of a human friendly unit. This mode is useful when scripting the batch mode of iotop. Instead of choosing the most appropriate unit iotop will display all sizes in kilobytes.
+.TP
+\fB\-t\fR, \fB\-\-time\fR
+Add a timestamp on each line (implies --batch). Each line will be prefixed by the current time.
+.TP
+\fB\-q\fR, \fB\-\-quiet\fR
+suppress some lines of header (implies --batch). This option can be specified up to three times to remove header lines.
+.RS
+.PD 0
+.TP
+.B -q
+column names are only printed on the first iteration,
+.TP
+.B -qq
+column names are never printed,
+.TP
+.B -qqq
+the I/O summary is never printed.
+.PD 1
+.RE
 .SH SEE ALSO
-.BR top (1)
+.BR top (1),
+.BR vmstat (1)
 .SH AUTHOR
 iotop was written by Guillaume Chazarain.
 .PP

=== modified file 'iotop/data.py'
--- iotop/data.py	2009-02-24 18:09:50 +0000
+++ iotop/data.py	2009-05-04 14:17:06 +0000
@@ -1,11 +1,15 @@
 import errno
+import glob
 import os
+import pprint
 import pwd
 import socket
+import stat
 import struct
 import sys
 import time
 
+from iotop import ioprio, vmstat
 from netlink import Connection, NETLINK_GENERIC, U32Attr, NLM_F_REQUEST
 from genetlink import Controller, GeNlMessage
 
@@ -27,20 +31,23 @@
         return boolean and 'Found' or 'Not found'
     print 'Could not run iotop as some of the requirements are not met:'
     print '- Python >= 2.5 for AF_NETLINK support:', boolean2string(python25)
-    print '- Linux >= 2.6.20 with I/O accounting support:', \
+    print '- Linux >= 2.6.20 with I/O accounting support ' \
+             '(CONFIG_TASKSTATS, CONFIG_TASK_DELAY_ACCT, ' \
+             'CONFIG_TASK_IO_ACCOUNTING):', \
           boolean2string(ioaccounting)
     sys.exit(1)
 
-#
-# Netlink usage for taskstats
-#
-
-TASKSTATS_CMD_GET = 1
-TASKSTATS_CMD_ATTR_PID = 1
-TASKSTATS_CMD_ATTR_TGID = 2
-
-class TaskStatsNetlink(object):
-    # Keep in sync with human_stats(stats, duration) and pinfo.did_some_io()
+class DumpableObject(object):
+    """Base class for all objects that allows easy introspection when printed"""
+    def __repr__(self):
+        return '%s: %s>' % (str(type(self))[:-1], pprint.pformat(self.__dict__))
+
+
+#
+# Interesting fields in a taskstats output
+#
+
+class Stats(DumpableObject):
     members_offsets = [
         ('blkio_delay_total', 40),
         ('swapin_delay_total', 56),
@@ -49,19 +56,58 @@
         ('cancelled_write_bytes', 264)
     ]
 
+    def __init__(self, task_stats_buffer):
+        for name, offset in Stats.members_offsets:
+            data = task_stats_buffer[offset:offset + 8]
+            setattr(self, name, struct.unpack('Q', data)[0])
+
+    def accumulate(self, other_stats, operator=sum):
+        """Returns a new Stats object built from operator(self, other_stats)"""
+        delta_stats = Stats.__new__(Stats)
+        for name, offset in Stats.members_offsets:
+            self_value = getattr(self, name)
+            other_value = getattr(other_stats, name)
+            setattr(delta_stats, name, operator((self_value, other_value)))
+        return delta_stats
+
+    def delta(self, other_stats):
+        """Returns self - other_stats"""
+        def subtract((me, other)):
+            return me - other
+        return self.accumulate(other_stats, operator=subtract)
+
+    def is_all_zero(self):
+        for name, offset in Stats.members_offsets:
+            if getattr(self, name) != 0:
+                return False
+        return True
+
+    @staticmethod
+    def build_all_zero():
+        stats = Stats.__new__(Stats)
+        for name, offset in Stats.members_offsets:
+            setattr(stats, name, 0)
+        return stats
+
+#
+# Netlink usage for taskstats
+#
+
+TASKSTATS_CMD_GET = 1
+TASKSTATS_CMD_ATTR_PID = 1
+
+class TaskStatsNetlink(object):
+    # Keep in sync with format_stats() and pinfo.did_some_io()
+
     def __init__(self, options):
         self.options = options
         self.connection = Connection(NETLINK_GENERIC)
         controller = Controller(self.connection)
         self.family_id = controller.get_family_id('TASKSTATS')
 
-    def get_task_stats(self, pid):
-        if self.options.processes:
-            attr = TASKSTATS_CMD_ATTR_TGID
-        else:
-            attr = TASKSTATS_CMD_ATTR_PID
+    def get_single_task_stats(self, pid):
         request = GeNlMessage(self.family_id, cmd=TASKSTATS_CMD_GET,
-                              attrs=[U32Attr(attr, pid)],
+                              attrs=[U32Attr(TASKSTATS_CMD_ATTR_PID, pid)],
                               flags=NLM_F_REQUEST)
         request.send(self.connection)
         try:
@@ -79,21 +125,16 @@
         reply_length, reply_type = struct.unpack('HH', reply.payload[4:8])
         reply_version = struct.unpack('H', reply.payload[20:22])[0]
         assert reply_length >= 288
-        assert reply_type == attr + 3
+        assert reply_type == TASKSTATS_CMD_ATTR_PID + 3
         assert reply_version >= 4
-
-        res = {}
-        for name, offset in TaskStatsNetlink.members_offsets:
-            data = reply_data[offset: offset + 8]
-            res[name] = struct.unpack('Q', data)[0]
-
-        return res
+        return Stats(reply_data)
 
 #
 # PIDs manipulations
 #
 
 def find_uids(options):
+    """Build options.uids from options.users by resolving usernames to UIDs"""
     options.uids = []
     error = False
     for u in options.users or []:
@@ -118,38 +159,90 @@
     except UnicodeDecodeError:
         return s.encode('string_escape')
 
-class pinfo(object):
-    def __init__(self, pid, options):
-        self.mark = False
+class ThreadInfo(DumpableObject):
+    """Stats for a single thread"""
+    def __init__(self, tid):
+        self.tid = tid
+        self.mark = True
+        self.stats_total = None
+        self.stats_delta = None
+
+    def get_ioprio(self):
+        return ioprio.get(self.tid)
+
+    def update_stats(self, stats):
+        if not self.stats_total:
+            self.stats_total = stats
+        self.stats_delta = stats.delta(self.stats_total)
+        self.stats_total = stats
+
+
+class ProcessInfo(DumpableObject):
+    """Stats for a single process (a single line in the output): if
+    options.processes is set, it is a collection of threads, otherwise a single
+    thread."""
+    def __init__(self, pid):
         self.pid = pid
-        self.stats = {}
-        for name, offset in TaskStatsNetlink.members_offsets:
-            self.stats[name] = (0, 0) # Total, Delta
-        self.parse_status('/proc/%d/status' % pid, options)
-
-    def check_if_valid(self, uid, options):
-        self.valid = options.pids or not options.uids or uid in options.uids
-
-    def parse_status(self, path, options):
-        for line in open(path):
-            if line.startswith('Name:'):
-                # Name kernel threads
-                self.name = '[' + line.split()[1].strip() + ']'
-            elif line.startswith('Uid:'):
-                uid = int(line.split()[1])
-                # We check monitored PIDs only here
-                self.check_if_valid(uid, options)
-                try:
-                    self.user = safe_utf8_decode(pwd.getpwuid(uid).pw_name)
-                except KeyError:
-                    self.user = str(uid)
-                break
-
-    def add_stats(self, stats):
-        self.stats_timestamp = time.time()
-        for name, value in stats.iteritems():
-            prev_value = self.stats[name][0]
-            self.stats[name] = (value, value - prev_value)
+        self.uid = None
+        self.user = None
+        self.threads = {} # {tid: ThreadInfo}
+        self.stats_delta = Stats.build_all_zero()
+        self.stats_accum = Stats.build_all_zero()
+        self.stats_accum_timestamp = time.time()
+
+    def is_monitored(self, options):
+        if (options.pids and not options.processes and
+            self.pid not in options.pids):
+            # We only monitor some threads, not this one
+            return False
+
+        if options.uids and self.get_uid() not in options.uids:
+            # We only monitor some users, not this one
+            return False
+
+        return True
+
+    def get_uid(self):
+        if self.uid:
+            return self.uid
+        # uid in (None, 0) means either we don't know the UID yet or the process
+        # runs as root so it can change its UID. In both cases it means we have
+        # to find out its current UID.
+        try:
+            uid = os.stat('/proc/%d' % self.pid)[stat.ST_UID]
+        except OSError:
+            # The process disappeared
+            uid = None
+        if uid != self.uid:
+            # Maybe the process called setuid()
+            self.user = None
+        return uid
+
+    def get_user(self):
+        uid = self.get_uid()
+        if uid is not None and not self.user:
+            try:
+                self.user = safe_utf8_decode(pwd.getpwuid(uid).pw_name)
+            except KeyError:
+                self.user = str(uid)
+        return self.user or '{none}'
+
+    def get_proc_status_name(self):
+        try:
+            proc_status = open('/proc/%d/status' % self.pid)
+        except IOError:
+            return '{no such process}'
+        first_line = proc_status.readline()
+        prefix = 'Name:\t'
+        if first_line.startswith(prefix):
+            name = first_line[6:].strip()
+        else:
+            name = ''
+        if name:
+            name = '[%s]' % name
+        else:
+            name = '{no name}'
+        return name
 
     def get_cmdline(self):
         # A process may exec, so we must always reread its cmdline
@@ -158,80 +251,135 @@
             cmdline = proc_cmdline.read(4096)
         except IOError:
             return '{no such process}'
+        if not cmdline:
+            # Probably a kernel thread, get its name from /proc/PID/status
+            return self.get_proc_status_name()
         parts = cmdline.split('\0')
         if parts[0].startswith('/'):
             first_command_char = parts[0].rfind('/') + 1
             parts[0] = parts[0][first_command_char:]
         cmdline = ' '.join(parts).strip()
-        return safe_utf8_decode(cmdline or self.name)
+        return safe_utf8_decode(cmdline)
 
     def did_some_io(self):
-        for name in self.stats:
-            if self.stats[name][1]:
-                return True
-
-        return False
-
-class ProcessList(object):
+        return not all(t.stats_delta.is_all_zero() for
+                                                 t in self.threads.itervalues())
+
+    def get_ioprio(self):
+        priorities = set(t.get_ioprio() for t in self.threads.itervalues())
+        if len(priorities) == 1:
+            return priorities.pop()
+        return '?'
+
+    def ioprio_sort_key(self):
+        return ioprio.sort_key(self.get_ioprio())
+
+    def get_thread(self, tid):
+        thread = self.threads.get(tid, None)
+        if not thread:
+            thread = ThreadInfo(tid)
+            self.threads[tid] = thread
+        return thread
+
+    def update_stats(self):
+        stats_delta = Stats.build_all_zero()
+        for tid, thread in self.threads.items():
+            if thread.mark:
+                del self.threads[tid]
+            else:
+                stats_delta = stats_delta.accumulate(thread.stats_delta)
+
+        nr_threads = len(self.threads)
+        if not nr_threads:
+            return False
+
+        stats_delta.blkio_delay_total /= nr_threads
+        stats_delta.swapin_delay_total /= nr_threads
+
+        self.stats_delta = stats_delta
+        self.stats_accum = self.stats_accum.accumulate(self.stats_delta)
+
+        return True
+
+class ProcessList(DumpableObject):
     def __init__(self, taskstats_connection, options):
-        # {pid: pinfo}
+        # {pid: ProcessInfo}
         self.processes = {}
         self.taskstats_connection = taskstats_connection
         self.options = options
         self.timestamp = time.time()
+        self.vmstat = vmstat.VmStat()
 
         # A first time as we are interested in the delta
         self.update_process_counts()
 
     def get_process(self, pid):
+        """Either get the specified PID from self.processes or build a new
+        ProcessInfo if we see this PID for the first time"""
         process = self.processes.get(pid, None)
         if not process:
-            try:
-                process = pinfo(pid, self.options)
-            except IOError:
-                # IOError: [Errno 2] No such file or directory: '/proc/...'
-                return
-            if not process.valid:
-                return
+            process = ProcessInfo(pid)
             self.processes[pid] = process
-        return process
-
-    def list_pids(self, tgid):
-        if self.options.processes or self.options.pids:
+
+        if process.is_monitored(self.options):
+            return process
+
+    def list_tgids(self):
+        if self.options.pids:
+            for pid in self.options.pids:
+                yield pid
+
+        pattern = '/proc/[0-9]*'
+        if not self.options.processes:
+            pattern += '/task/*'
+
+        for path in glob.iglob(pattern):
+            yield int(os.path.basename(path))
+
+    def list_tids(self, tgid):
+        if not self.options.processes:
             return [tgid]
+
         try:
-            return map(int, os.listdir('/proc/%d/task' % tgid))
+            tids = map(int, os.listdir('/proc/%d/task' % tgid))
         except OSError:
             return []
 
+        if self.options.pids:
+            tids = list(set(self.options.pids).intersection(set(tids)))
+
+        return tids
+
     def update_process_counts(self):
         new_timestamp = time.time()
         self.duration = new_timestamp - self.timestamp
         self.timestamp = new_timestamp
-        total_read = total_write = 0
-        tgids = self.options.pids or [int(tgid) for tgid in os.listdir('/proc')
-                                      if '0' <= tgid[0] and tgid[0] <= '9']
-        for tgid in tgids:
-            for pid in self.list_pids(tgid):
-                process = self.get_process(pid)
-                if process:
-                    stats = self.taskstats_connection.get_task_stats(pid)
-                    if stats:
-                        process.mark = False
-                        process.add_stats(stats)
-                        total_read += process.stats['read_bytes'][1]
-                        total_write += process.stats['write_bytes'][1]
-        return total_read, total_write
+
+        for tgid in self.list_tgids():
+            process = self.get_process(tgid)
+            if not process:
+                continue
+            for tid in self.list_tids(tgid):
+                thread = process.get_thread(tid)
+                stats = self.taskstats_connection.get_single_task_stats(tid)
+                if stats:
+                    thread.update_stats(stats)
+                    thread.mark = False
+
+        return self.vmstat.delta()
 
     def refresh_processes(self):
-        for process in self.processes.values():
-            process.mark = True
+        for process in self.processes.itervalues():
+            for thread in process.threads.itervalues():
+                thread.mark = True
+
         total_read_and_write = self.update_process_counts()
-        to_delete = []
-        for pid, process in self.processes.iteritems():
-            if process.mark:
-                to_delete.append(pid)
-        for pid in to_delete:
-            del self.processes[pid]
+
+        for pid, process in self.processes.items():
+            if not process.update_stats():
+                del self.processes[pid]
+
         return total_read_and_write
 
+    def clear(self):
+        self.processes = {}

=== added file 'iotop/ioprio.py'
--- iotop/ioprio.py	1970-01-01 00:00:00 +0000
+++ iotop/ioprio.py	2009-05-04 14:17:06 +0000
@@ -0,0 +1,97 @@
+import ctypes
+import fnmatch
+import os
+import time
+
+# From http://git.kernel.org/?p=utils/util-linux-ng/util-linux-ng.git;a=blob;
+#      f=configure.ac;h=770eb45ae85d32757fc3cff1d70a7808a627f9f7;hb=HEAD#l363
+IOPRIO_GET_ARCH_SYSCALL = [
+    ('alpha',    443),
+    ('i*86',     290),
+    ('ia64*',    1275),
+    ('powerpc*', 274),
+    ('s390*',    283),
+    ('sparc*',   218),
+    ('sh*',      289),
+    ('x86_64*',  252),
+]
+
+def find_ioprio_get_syscall_number():
+    arch = os.uname()[4]
+
+    for candidate_arch, syscall_nr in IOPRIO_GET_ARCH_SYSCALL:
+        if fnmatch.fnmatch(arch, candidate_arch):
+            return syscall_nr
+
+
+__NR_ioprio_get = find_ioprio_get_syscall_number()
+ctypes_handle = ctypes.CDLL(None)
+syscall = ctypes_handle.syscall
+
+PRIORITY_CLASSES = (None, 'rt', 'be', 'idle')
+
+WHO_PROCESS = 1
+IOPRIO_CLASS_SHIFT = 13
+IOPRIO_PRIO_MASK = (1 << IOPRIO_CLASS_SHIFT) - 1
+
+def ioprio_class(ioprio):
+    return PRIORITY_CLASSES[ioprio >> IOPRIO_CLASS_SHIFT]
+
+def ioprio_data(ioprio):
+    return ioprio & IOPRIO_PRIO_MASK
+
+sched_getscheduler = ctypes_handle.sched_getscheduler
+SCHED_OTHER, SCHED_FIFO, SCHED_RR, SCHED_BATCH, SCHED_ISO, SCHED_IDLE = range(6)
+
+def get_ioprio_from_sched(pid):
+    scheduler = sched_getscheduler(pid)
+    nice = int(open('/proc/%d/stat' % pid).read().split()[18])
+    ioprio_nice = (nice + 20) / 5
+
+    if scheduler in (SCHED_FIFO, SCHED_RR):
+        return 'rt/%d' % ioprio_nice
+    elif scheduler == SCHED_IDLE:
+        return 'idle'
+    else:
+        return 'be/%d' % ioprio_nice
+
+def get(pid):
+    if __NR_ioprio_get is None:
+        return '?sys'
+
+    ioprio = syscall(__NR_ioprio_get, WHO_PROCESS, pid)
+    if ioprio < 0:
+        return '?err'
+
+    prio_class = ioprio_class(ioprio)
+    if not prio_class:
+        return get_ioprio_from_sched(pid)
+    if prio_class == 'idle':
+        return prio_class
+    return '%s/%d' % (prio_class, ioprio_data(ioprio))
+
+def sort_key(key):
+    if key[0] == '?':
+        return -ord(key[1])
+
+    if '/' in key:
+        if key.startswith('rt/'):
+            shift = 0
+        elif key.startswith('be/'):
+            shift = 1
+        prio = int(key.split('/')[1])
+    elif key == 'idle':
+        shift = 2
+        prio = 0
+
+    return (1 << (shift * IOPRIO_CLASS_SHIFT)) + prio
+
+if __name__ == '__main__':
+    import sys
+    if len(sys.argv) == 2:
+        pid = int(sys.argv[1])
+    else:
+        pid = os.getpid()
+    print 'pid:', pid
+    print 'ioprio:', get(pid)
+

=== modified file 'iotop/ui.py'
--- iotop/ui.py	2009-02-24 18:09:50 +0000
+++ iotop/ui.py	2009-05-04 14:17:06 +0000
@@ -7,6 +7,7 @@
 import select
 import struct
 import sys
+import time
 
 from iotop.data import find_uids, TaskStatsNetlink, ProcessList
 from iotop.version import VERSION
@@ -17,28 +18,43 @@
 
 UNITS = ['B', 'K', 'M', 'G', 'T', 'P', 'E']
 
-def human_bandwidth(size, duration):
-    bw = size and float(size) / duration
+def human_size(size):
     for i in xrange(len(UNITS) - 1, 0, -1):
         base = 1 << (10 * i)
         if 2 * base < size:
-            res = '%.2f %s' % ((float(bw) / base), UNITS[i])
             break
     else:
-        res = str(bw) + ' ' + UNITS[0]
-    return res + '/s'
-
-def human_stats(stats, duration):
+        i = 0
+        base = 1
+    return '%.2f %s' % ((float(size) / base), UNITS[i])
+
+def format_size(options, bytes):
+    if options.kilobytes:
+        return '%.2f K' % (bytes / 1024.0)
+    return human_size(bytes)
+
+def format_bandwidth(options, size, duration):
+    return format_size(options, size and float(size) / duration) + '/s'
+
+def format_stats(options, process, duration):
     # Keep in sync with TaskStatsNetlink.members_offsets and
     # IOTopUI.get_data(self)
-    def delay2percent(name): # delay in ns, duration in s
-        return '%.2f %%' % min(99.99, stats[name][1] / (duration * 10000000.0))
-    io_delay = delay2percent('blkio_delay_total')
-    swapin_delay = delay2percent('swapin_delay_total')
-    read_bytes = human_bandwidth(stats['read_bytes'][1], duration)
-    written_bytes = stats['write_bytes'][1] - stats['cancelled_write_bytes'][1]
+    def delay2percent(delay): # delay in ns, duration in s
+        return '%.2f %%' % min(99.99, delay / (duration * 10000000.0))
+    if options.accumulated:
+        stats = process.stats_accum
+        display_format = lambda size, duration: format_size(options, size)
+        duration = time.time() - process.stats_accum_timestamp
+    else:
+        stats = process.stats_delta
+        display_format = lambda size, duration: format_bandwidth(
+                                                        options, size, duration)
+    io_delay = delay2percent(stats.blkio_delay_total)
+    swapin_delay = delay2percent(stats.swapin_delay_total)
+    read_bytes = display_format(stats.read_bytes, duration)
+    written_bytes = stats.write_bytes - stats.cancelled_write_bytes
     written_bytes = max(0, written_bytes)
-    write_bytes = human_bandwidth(written_bytes, duration)
+    write_bytes = display_format(written_bytes, duration)
     return io_delay, swapin_delay, read_bytes, write_bytes
 
 #
@@ -49,24 +65,25 @@
     # key, reverse
     sorting_keys = [
         (lambda p: p.pid, False),
-        (lambda p: p.user, False),
-        (lambda p: p.stats['read_bytes'][1], True),
-        (lambda p: p.stats['write_bytes'][1] -
-                   p.stats['cancelled_write_bytes'][1], True),
-        (lambda p: p.stats['swapin_delay_total'][1], True),
+        (lambda p: p.ioprio_sort_key(), False),
+        (lambda p: p.get_user(), False),
+        (lambda p: p.stats_delta.read_bytes, True),
+        (lambda p: p.stats_delta.write_bytes -
+                   p.stats_delta.cancelled_write_bytes, True),
+        (lambda p: p.stats_delta.swapin_delay_total, True),
         # The default sorting (by I/O % time) should show processes doing
         # only writes, without waiting on them
-        (lambda p: p.stats['blkio_delay_total'][1] or
-                   int(not(not(p.stats['read_bytes'][1] or
-                               p.stats['write_bytes'][1]))), True),
+        (lambda p: p.stats_delta.blkio_delay_total or
+                   int(not(not(p.stats_delta.read_bytes or
+                               p.stats_delta.write_bytes))), True),
         (lambda p: p.get_cmdline(), False),
     ]
 
     def __init__(self, win, process_list, options):
         self.process_list = process_list
         self.options = options
-        self.sorting_key = 5
-        self.sorting_reverse = IOTopUI.sorting_keys[5][1]
+        self.sorting_key = 6
+        self.sorting_reverse = IOTopUI.sorting_keys[self.sorting_key][1]
         if not self.options.batch:
             self.win = win
             self.resize()
@@ -91,12 +108,14 @@
               iterations < self.options.iterations:
             total = self.process_list.refresh_processes()
             total_read, total_write = total
-            self.refresh_display(total_read, total_write,
+            self.refresh_display(iterations == 0, total_read, total_write,
                                  self.process_list.duration)
             if self.options.iterations is not None:
                 iterations += 1
                 if iterations >= self.options.iterations:
                     break
+            elif iterations == 0:
+                iterations = 1
 
             try:
                 events = poll.poll(self.options.delay_seconds * 1000.0)
@@ -123,8 +142,15 @@
             self.sorting_reverse = IOTopUI.sorting_keys[self.sorting_key][1]
 
     def handle_key(self, key):
+        def toggle_accumulated():
+            self.options.accumulated ^= True
+            self.process_list.clear()
         def toggle_only_io():
             self.options.only ^= True
+        def toggle_processes():
+            self.options.processes ^= True
+            self.process_list.clear()
+            self.process_list.refresh_processes()
         key_bindings = {
             ord('q'):
                 lambda: sys.exit(0),
@@ -134,8 +160,18 @@
                 lambda: self.reverse_sorting(),
             ord('R'):
                 lambda: self.reverse_sorting(),
+            ord('a'):
+                toggle_accumulated,
+            ord('A'):
+                toggle_accumulated,
             ord('o'):
                 toggle_only_io,
+            ord('O'):
+                toggle_only_io,
+            ord('p'):
+                toggle_processes,
+            ord('P'):
+                toggle_processes,
             curses.KEY_LEFT:
                 lambda: self.adjust_sorting_key(-1),
             curses.KEY_RIGHT:
@@ -151,10 +187,11 @@
 
     def get_data(self):
         def format(p):
-            stats = human_stats(p.stats, self.process_list.duration)
+            stats = format_stats(self.options, p, self.process_list.duration)
             io_delay, swapin_delay, read_bytes, write_bytes = stats
-            line = '%5d %-8s %11s %11s %7s %7s ' % (p.pid, p.user[:8],
-                                read_bytes, write_bytes, swapin_delay, io_delay)
+            line = '%5d %4s %-8s %11s %11s %7s %7s ' % (
+                p.pid, p.get_ioprio(), p.get_user()[:8], read_bytes,
+                write_bytes, swapin_delay, io_delay)
             line += p.get_cmdline()
             if not self.options.batch:
                 line = line[:self.width - 1]
@@ -163,26 +200,36 @@
         def should_format(p):
             return not self.options.only or p.did_some_io()
 
-        processes = self.process_list.processes.values()
-        processes = filter(should_format, processes)
+        processes = filter(should_format, self.process_list.processes.values())
         key = IOTopUI.sorting_keys[self.sorting_key][0]
         processes.sort(key=key, reverse=self.sorting_reverse)
         if not self.options.batch:
             del processes[self.height - 2:]
         return map(format, processes)
 
-    def refresh_display(self, total_read, total_write, duration):
+    def refresh_display(self, first_time, total_read, total_write, duration):
         summary = 'Total DISK READ: %s | Total DISK WRITE: %s' % (
-                                        human_bandwidth(total_read, duration),
-                                        human_bandwidth(total_write, duration))
-        titles = ['  PID', ' USER', '      DISK READ', '  DISK WRITE',
-                  '   SWAPIN', '    IO', '    COMMAND']
+                          format_bandwidth(self.options, total_read, duration),
+                          format_bandwidth(self.options, total_write, duration))
+        if self.options.processes:
+            pid = '  PID'
+        else:
+            pid = '  TID'
+        titles = [pid, '  PRIO', '  USER', '     DISK READ', '  DISK WRITE',
+                  '  SWAPIN', '      IO', '    COMMAND']
         lines = self.get_data()
+        if self.options.time:
+            titles = ['    TIME'] + titles
+            current_time = time.strftime('%H:%M:%S ')
+            lines = [current_time + l for l in lines]
         if self.options.batch:
-            print summary
-            print ''.join(titles)
+            if self.options.quiet <= 2:
+                print summary
+                if self.options.quiet <= int(first_time):
+                    print ''.join(titles)
             for l in lines:
                 print l
+            sys.stdout.flush()
         else:
             self.win.erase()
             self.win.addstr(summary)
@@ -191,19 +238,60 @@
                 attr = curses.A_REVERSE
                 title = titles[i]
                 if i == self.sorting_key:
+                    title = title[1:]
+                if i == self.sorting_key:
                     attr |= curses.A_BOLD
                     title += self.sorting_reverse and '>' or '<'
                 self.win.addstr(title, attr)
             for i in xrange(len(lines)):
-                self.win.addstr(i + 2, 0, lines[i].encode('utf-8'))
+                try:
+                    self.win.addstr(i + 2, 0, lines[i].encode('utf-8'))
+                except curses.error:
+                    exc_type, value, traceback = sys.exc_info()
+                    value = '%s win:%s i:%d line:%s' % \
+                                       (value, self.win.getmaxyx(), i, lines[i])
+                    value = str(value).encode('string_escape')
+                    raise exc_type, value, traceback
             self.win.refresh()
 
-def run_iotop(win, options):
+def run_iotop_window(win, options):
     taskstats_connection = TaskStatsNetlink(options)
     process_list = ProcessList(taskstats_connection, options)
     ui = IOTopUI(win, process_list, options)
     ui.run()
 
+def run_iotop(options):
+    if options.batch:
+        return run_iotop_window(None, options)
+    else:
+        return curses.wrapper(run_iotop_window, options)
+
+#
+# Profiling
+#
+
+def _profile(continuation):
+    prof_file = 'iotop.prof'
+    try:
+        import cProfile
+        import pstats
+        print 'Profiling using cProfile'
+        cProfile.runctx('continuation()', globals(), locals(), prof_file)
+        stats = pstats.Stats(prof_file)
+    except ImportError:
+        import hotshot
+        import hotshot.stats
+        prof = hotshot.Profile(prof_file, lineevents=1)
+        print 'Profiling using hotshot'
+        prof.runcall(continuation)
+        prof.close()
+        stats = hotshot.stats.load(prof_file)
+    stats.strip_dirs()
+    stats.sort_stats('time', 'calls')
+    stats.print_stats(50)
+    stats.print_callees(50)
+    os.remove(prof_file)
+
 #
 # Main program
 #
@@ -212,10 +300,12 @@
 
 DISK READ and DISK WRITE are the block I/O bandwidth used during the sampling
 period. SWAPIN and IO are the percentages of time the thread spent respectively
-while swapping in and waiting on I/O more generally.
+while swapping in and waiting on I/O more generally. PRIO is the I/O priority at
+which the thread is running (set using the ionice command).
+
 Controls: left and right arrows to change the sorting column, r to invert the
-sorting order, o to toggle the --only option, q to quit, any other key to force
-a refresh''' % sys.argv[0]
+sorting order, o to toggle the --only option, p to toggle the --processes
+option, a to toggle the --accumulated option, q to quit, any other key to force a refresh.''' % sys.argv[0]
 
 def main():
     locale.setlocale(locale.LC_ALL, '')
@@ -232,19 +322,41 @@
                       help='delay between iterations [1 second]',
                       metavar='SEC', default=1)
     parser.add_option('-p', '--pid', type='int', dest='pids', action='append',
-                      help='processes to monitor [all]', metavar='PID')
+                      help='processes/threads to monitor [all]', metavar='PID')
     parser.add_option('-u', '--user', type='str', dest='users', action='append',
                       help='users to monitor [all]', metavar='USER')
     parser.add_option('-P', '--processes', action='store_true',
-                      dest='processes',
+                      dest='processes', default=False,
                       help='only show processes, not all threads')
+    parser.add_option('-a', '--accumulated', action='store_true',
+                      dest='accumulated', default=False,
+                      help='show accumulated I/O instead of bandwidth')
+    parser.add_option('-k', '--kilobytes', action='store_true',
+                      dest='kilobytes', default=False,
+                      help='use kilobytes instead of a human friendly unit')
+    parser.add_option('-t', '--time', action='store_true', dest='time',
+                      help='add a timestamp on each line (implies --batch)')
+    parser.add_option('-q', '--quiet', action='count', dest='quiet',
+                      help='suppress some lines of header (implies --batch)')
+    parser.add_option('--profile', action='store_true', dest='profile',
+                      default=False, help=optparse.SUPPRESS_HELP)
+
     options, args = parser.parse_args()
     if args:
         parser.error('Unexpected arguments: ' + ' '.join(args))
     find_uids(options)
     options.pids = options.pids or []
-    if options.batch:
-        run_iotop(None, options)
+    options.batch = options.batch or options.time or options.quiet
+
+    main_loop = lambda: run_iotop(options)
+
+    if options.profile:
+        def safe_main_loop():
+            try:
+                main_loop()
+            except:
+                pass
+        _profile(safe_main_loop)
     else:
-        curses.wrapper(run_iotop, options)
+        main_loop()
 

=== modified file 'iotop/version.py'
--- iotop/version.py	2009-02-24 18:09:50 +0000
+++ iotop/version.py	2009-05-04 14:17:06 +0000
@@ -1,1 +1,1 @@
-VERSION = '0.2.1'
+VERSION = '0.3'

=== added file 'iotop/vmstat.py'
--- iotop/vmstat.py	1970-01-01 00:00:00 +0000
+++ iotop/vmstat.py	2009-05-04 14:17:06 +0000
@@ -0,0 +1,30 @@
+import os
+
+class VmStat(object):
+    def __init__(self):
+        self.vmstat_file = open('/proc/vmstat')
+        self.vmstat = self.read()
+
+    def read(self):
+        def extract(line):
+            return int(line.split()[1]) * 1024
+
+        for line in self.vmstat_file:
+            if line.startswith('pgpgin '):
+                pgpgin = extract(line)
+                break
+
+        for line in self.vmstat_file:
+            if line.startswith('pgpgout '):
+                pgpgout = extract(line)
+                break
+
+        self.vmstat_file.seek(0)
+        return pgpgin, pgpgout
+
+    def delta(self):
+        now = self.read()
+        delta = now[0] - self.vmstat[0], now[1] - self.vmstat[1]
+        self.vmstat = now
+        return delta
+

=== modified file 'setup.cfg'
--- setup.cfg	2008-05-29 17:31:58 +0000
+++ setup.cfg	2009-05-04 14:17:06 +0000
@@ -1,3 +1,3 @@
 [bdist_rpm]
 install_script = install-rpm.sh
-doc_files = COPYING NEWS THANKS
+doc_files = ChangeLog COPYING NEWS THANKS

=== modified file 'setup.py'
--- setup.py	2008-05-29 17:31:58 +0000
+++ setup.py	2009-05-04 14:17:06 +0000
@@ -2,7 +2,7 @@
 
 import sys
 
-sys.path.insert(0, 'setuptools-0.6c6-py2.4.egg')
+sys.path.insert(0, 'setuptools-0.6c9-py2.4.egg')
 from setuptools import setup, find_packages
 from iotop.version import VERSION
 

=== removed file 'setuptools-0.6c6-py2.4.egg'
Binary files setuptools-0.6c6-py2.4.egg and setuptools-0.6c6-py2.4.egg differ
=== added file 'setuptools-0.6c9-py2.4.egg'
Binary files setuptools-0.6c9-py2.4.egg and setuptools-0.6c9-py2.4.egg differ
